@echo off %debug%
setlocal ENABLEDELAYEDEXPANSION	
rem ist_verzeichis.cmd (c) 2008 c't & Johannes Endres
rem In Unix-Shells lautet der Befehl 
rem test -d $1 && echo $1 ist ein Verzeichnis.

rem Wenn das Objekt gar nicht exisitiert, ist die Prfung nicht sinnvoll
if not exist "%~f1" (
	echo "%~f1" ist weder Datei noch Verzeichnis.
	exit/B
)

rem Hier beginnt der Verzeichnistest
rem Zuerst fngt ein einfacher dir-Befehl die meisten Flle ab
set _ist_ein_verzeichnis_=
dir /a:d %~s1 >nul 2>nul && (
	set _ist_ein_verzeichnis_=1
	goto _ende_des_verzeichnistests_
)

rem An dieser Stelle im Ablauf ist %1 entweder eine Datei
rem oder ein Verzeichnis, das der angemeldete User nicht lesen darf.

rem Prfung des zweiten Falls: Es ist das Root-Verzeichnis eines Laufwerks
rem und kein Leserecht 
rem Wenn wir lesen drften, htte es der erste Fall abgefangen.
rem Die Methode: Prfen, ob %1 nur aus dem Laufwerksbuchstaben mit einem \ besteht.
rem Merke: Nackte Laufwerksbuchstaben wie C: verweisen auf das aktuelle 
rem Arbeitsverzeichnis auf dem Laufwerk, also normalerweise nicht aufs Root-Verzeichnis.
if "$~d1\"=="%~f1" (
	set _ist_ein_verzeichnis_=1
	goto _ende_des_verzeichnistests_
)

rem Der letzte Fall: Verzeichnis ohne Leserecht
rem Die Methode: Im bergeordneten Verzeichnis mit dir nachsehen,
rem ob es ein Verzeichnis des angegebenen Namens gibt
rem Das bergeordnete Verzeichnis soll soll in die Variable %_verz_%,
rem der Name in %_name_%:
set _verz_=%~sdp1
set _name_=%~snx1

rem Wenn %1 mit einem \ am Ende angegeben wurde, steht alles in %_verz_%
rem und %_name_% ist leer. In diesem Falle verschiebt die Unterfunktion
rem alles um eine Stelle.
if not defined _name_ (
	set _x_=%~s1
	call :trimpath !_x_:~0,-1!
	)

rem Nur die Verzeichnisse im bergeordneten auflisten und darin den Namen suchen
dir /a:d /x %_verz_% 2>nul | findstr /i "%_name_%" >nul && set _ist_ein_verzeichnis_=1
:_ende_des_verzeichnistests_
rem Hier ist der Test beendet.
rem Der Abschnitt von :trimpath bis zum Dateiende gehrt jedoch dazu.

rem Es gibt mindestens einen Fall, den das Skript hier noch nicht abgefangen hat.
rem Wer eine korrekte Beschreibung an je@heise.de mailt, bekommt ein virtuelles Fleikrtchen.
rem Theoretische berlegungen zhlen nicht, es mus ausprobiert sein.
rem Wer eine Lsung mitschickt, bekommt sogar zwei virtuelle Fleikrtchen ;-)

rem Hier knnte das Skript auch etwas anderes tun
if defined _ist_ein_verzeichnis_ (
	echo "%~f1" ist ein Verzeichnis.
) else (
	echo "%~f1" ist eine Datei.
)
exit/b

:trimpath
set _verz_=%~dp1
set _name_=%~nx1
exit/b